VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   Caption         =   "frmMain"
   ClientHeight    =   6795
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   9480
   Icon            =   "MAIN.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6795
   ScaleWidth      =   9480
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrDelay 
      Left            =   120
      Top             =   1800
   End
   Begin MSWinsockLib.Winsock wskTelnet 
      Left            =   600
      Top             =   1320
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock wskBNet 
      Left            =   120
      Top             =   1320
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSComctlLib.ImageList imlNickList 
      Left            =   1800
      Top             =   960
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   393216
   End
   Begin MSComctlLib.ListView lvwNickList 
      Height          =   735
      Left            =   1800
      TabIndex        =   2
      Top             =   120
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   1296
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      SmallIcons      =   "imlNickList"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.ComboBox cboChat 
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   1215
   End
   Begin RichTextLib.RichTextBox rtfChat 
      Height          =   735
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   1296
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"MAIN.frx":0E42
   End
   Begin VB.Label lblChannelName 
      Caption         =   "lblChannelName"
      Height          =   195
      Left            =   3480
      TabIndex        =   1
      Top             =   120
      Width           =   1155
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuConnect 
         Caption         =   "&Connect"
      End
      Begin VB.Menu mnuDisconnect 
         Caption         =   "&Disconnect"
      End
      Begin VB.Menu mnuSpace 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSetup 
         Caption         =   "&Setup..."
      End
      Begin VB.Menu mnuSpace1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuSpace2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSelectAll 
         Caption         =   "Select &All"
         Shortcut        =   ^A
      End
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      Begin VB.Menu mnuAlwaysOnTop 
         Caption         =   "Always On &Top"
         Shortcut        =   ^Y
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "&About..."
      End
   End
   Begin VB.Menu pop_rtfChat 
      Caption         =   "rtfChat"
      Begin VB.Menu popCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu popSpace 
         Caption         =   "-"
      End
      Begin VB.Menu popSelectAll 
         Caption         =   "Select &All"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'MAIN.FRM (frmMain) - Ickis <ickis@toctep.com>.

'MMII Weatherspoon Labs <http://toctep.com/>.  All rights reserved.

'Permission to use, copy, modify, and distribute this software and its
'documentation for non-commercial purposes and without fee is hereby granted.

Option Explicit

Private m_s$
Private m_TelnetLogon As Boolean

Private Sub cboChat_KeyPress(KeyAscii As Integer)
    Dim i&
    Dim s$
    Dim r&
    
    If Len(cboChat.Text) > 255 Then KeyAscii = 0
    If (KeyAscii = vbKeyReturn) And (cboChat.Text <> "") And (wskBNet.State = 7) Then
        wskBNet.SendData cboChat.Text & vbCrLf
        If g_Telnet Then
            tmrDelay.Enabled = True
            Do While tmrDelay.Enabled
                DoEvents
            Loop
        End If
        If Left(cboChat.Text, 1) <> "/" Then AddChat vbCyan, "<" & g_ConnectedUsername & "> ", vbWhite, cboChat.Text
        s = cboChat.Text
        For i = (cboChat.ListCount - 1) To 1 Step -1
            cboChat.List(i) = cboChat.List(i - 1)
        Next i
        cboChat.List(0) = s
        cboChat.Text = ""
    ElseIf (KeyAscii = vbKeyReturn) And (cboChat.Text <> "") And (wskBNet.State <> 7) Then
        r = MsgBox("You are currently not connected.  You need to be connected to send messages." & vbNewLine & "Would you like to connect now?", vbYesNo + vbQuestion, App.Title & " Error")
        If r = vbYes Then mnuConnect_Click
    End If
End Sub

Private Sub Form_Load()
    Dim i&
    
    m_s = ""
    m_TelnetLogon = False
    pop_rtfChat.Visible = False
    Me.Caption = App.Title
    With imlNickList
        .ImageWidth = 28
        .ImageHeight = 14
        .ListImages.Add 1, "Blizzard Employee", LoadResPicture(101, 1)
        .ListImages.Add 2, "Channel Operator", LoadResPicture(102, 1)
        .ListImages.Add 3, "Speaker", LoadResPicture(103, 1)
        .ListImages.Add 4, "Battle.net System Administrator", LoadResPicture(104, 1)
        .ListImages.Add 5, "Squelched", LoadResPicture(105, 1)
        .ListImages.Add 6, "Spectator", LoadResPicture(106, 1)
        .ListImages.Add 7, "Battle.net Chat Participant", LoadResPicture(107, 1)
        .ListImages.Add 8, "Diablo", LoadResPicture(108, 1)
        .ListImages.Add 9, "Diablo: Shareware", LoadResPicture(109, 1)
        .ListImages.Add 10, "StarCraft", LoadResPicture(110, 1)
        .ListImages.Add 11, "StarCraft: Shareware", LoadResPicture(111, 1)
        .ListImages.Add 12, "Japanese StarCraft", LoadResPicture(112, 1)
        .ListImages.Add 13, "StarCraft: Brood War", LoadResPicture(113, 1)
        .ListImages.Add 14, "Warcraft II Battle.net Edition", LoadResPicture(114, 1)
        .ListImages.Add 15, "Diablo II", LoadResPicture(115, 1)
        .ListImages.Add 16, "Diablo II Lord of Destruction", LoadResPicture(116, 1)
        .ListImages.Add 17, "Warcraft III: Reign of Chaos", LoadResPicture(117, 1)
        .ListImages.Add 18, "Unknown", LoadResPicture(118, 1)
    End With
    With lvwNickList
        .Top = lblChannelName.Height + (6 * Screen.TwipsPerPixelX)
        .Left = rtfChat.Width
        .Width = (imlNickList.ImageWidth * Screen.TwipsPerPixelX) + (32 * Screen.TwipsPerPixelX) + TextWidth(String(12, "W"))
        .Height = Me.ScaleHeight - (lblChannelName.Height + cboChat.Height + (3 * Screen.TwipsPerPixelX))
        .ColumnHeaders.Add 1, "", "", (imlNickList.ImageWidth * Screen.TwipsPerPixelX) + (6 * Screen.TwipsPerPixelX) + TextWidth(String(12, "W"))
        .FullRowSelect = True
        .HideColumnHeaders = True
        .LabelEdit = lvwManual
        .View = lvwReport
        .PictureAlignment = lvwTile
        .ForeColor = vbWhite
        .BackColor = vbBlack
    End With
    With rtfChat
        .Top = 0
        .Left = 0
        .Width = Me.ScaleWidth - lvwNickList.Width
        .Height = Me.ScaleHeight - cboChat.Height
        .Locked = True
        .BackColor = vbBlack
    End With
    With lblChannelName
        .Top = 3 * Screen.TwipsPerPixelX
        .Left = rtfChat.Width
        .Width = lvwNickList.Width
        .Height = .Height + (3 * Screen.TwipsPerPixelX)
        .Alignment = vbCenter
        .Caption = ""
    End With
    With cboChat
        .Top = rtfChat.Height
        .Left = 0
        .Width = Me.ScaleWidth
        .ForeColor = vbWhite
        .BackColor = vbBlack
    End With
    For i = 0 To 49
        cboChat.AddItem "", i
    Next i
    tmrDelay.Enabled = False
    tmrDelay.Interval = 100
    CenterForm Me
    g_OnTop = CBool(Val((ReadINI("Setup", "On Top", FixPath(App.Path) & "assbot.ini"))))
    If g_OnTop Then mnuAlwaysOnTop_Click
    Me.Show
    cboChat.SetFocus
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    
    rtfChat.Width = Me.ScaleWidth - lvwNickList.Width
    rtfChat.Height = Me.ScaleHeight - cboChat.Height
    lblChannelName.Left = rtfChat.Width
    lblChannelName.Width = lvwNickList.Width
    lvwNickList.Left = rtfChat.Width
    lvwNickList.Height = Me.ScaleHeight - (lblChannelName.Height + cboChat.Height + (3 * Screen.TwipsPerPixelX))
    cboChat.Top = rtfChat.Height
    cboChat.Width = Me.ScaleWidth
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If wskBNet.State <> 0 Then wskBNet.Close
    If g_Telnet Then If wskTelnet.State <> 0 Then wskTelnet.Close
    Unload frmSetup
    Unload frmAbout
    Set frmMain = Nothing
End Sub

Private Sub lvwNickList_DblClick()
    If lvwNickList.ListItems.Count > 0 Then
        If Len(cboChat.Text & " " & lvwNickList.SelectedItem.Text) <= 255 Then
            cboChat.Text = cboChat.Text & lvwNickList.SelectedItem.Text & " "
            cboChat.SetFocus
        End If
    End If
End Sub

Private Sub lvwNickList_ItemClick(ByVal Item As MSComctlLib.ListItem)
    lvwNickList.ToolTipText = lvwNickList.SelectedItem.Text
End Sub

Private Sub lvwNickList_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then
        If lvwNickList.ListItems.Count > 0 Then
            cboChat.Text = lvwNickList.SelectedItem.Text
            cboChat.SetFocus
        End If
    End If
End Sub

Private Sub mnuAbout_Click()
    Dim r&
    
    r = SetWindowPos(Me.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    frmAbout.Show vbModal, Me
End Sub

Private Sub mnuAlwaysOnTop_Click()
    Dim r&

    If mnuAlwaysOnTop.Checked Then
        r = SetWindowPos(Me.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
        g_OnTop = False
        WriteINI "Setup", "On Top", CStr(CLng(g_OnTop)), FixPath(App.Path) & "assbot.ini"
        mnuAlwaysOnTop.Checked = False
    Else
        r = SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
        g_OnTop = True
        WriteINI "Setup", "On Top", CStr(CLng(g_OnTop)), FixPath(App.Path) & "assbot.ini"
        mnuAlwaysOnTop.Checked = True
    End If
End Sub

Public Sub mnuConnect_Click()
    If wskBNet.State <> 7 Then
        wskBNet.RemoteHost = g_Server
        wskBNet.RemotePort = 6112
        wskBNet.Connect
    End If
End Sub

Private Sub mnuCopy_Click()
    Clipboard.Clear
    Clipboard.SetText rtfChat.SelText, vbCFText
    rtfChat.SelLength = 0
End Sub

Private Sub mnuDisconnect_Click()
    If g_Telnet Then
        If wskTelnet.State <> 0 Then
            g_Telnet = False
            AddChat vbYellow, "Disconnected from " & wskTelnet.RemoteHost & " (" & wskTelnet.RemoteHostIP & ")."
            wskTelnet.SendData "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] Disconnected from " & wskTelnet.LocalHostName & " (" & wskTelnet.LocalIP & ")." & vbCrLf
            wskTelnet.Close
        End If
    End If
    If wskBNet.State <> 0 Then
        wskBNet.Close
        AddChat vbYellow, "Disconnected from Battle.net (" & g_Server & ")."
    End If
End Sub

Private Sub mnuEdit_Click()
    If rtfChat.SelLength > 0 Then
        mnuCopy.Enabled = True
        popCopy.Enabled = True
    Else
        mnuCopy.Enabled = False
        popCopy.Enabled = False
    End If
    If Len(rtfChat.Text) > 0 Then
        mnuSelectAll.Enabled = True
        popSelectAll.Enabled = True
    Else
        mnuSelectAll.Enabled = False
        popSelectAll.Enabled = False
    End If
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuFile_Click()
    If wskBNet.State = 0 Then
        mnuConnect.Enabled = True
        mnuDisconnect.Enabled = False
    ElseIf wskBNet.State = 7 Then
        mnuConnect.Enabled = False
        mnuDisconnect.Enabled = True
    End If
End Sub

Private Sub mnuSelectAll_Click()
    rtfChat.SelStart = 0
    rtfChat.SelLength = Len(rtfChat.Text)
End Sub

Private Sub mnuSetup_Click()
    Dim r&
    
    r = SetWindowPos(Me.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    frmSetup.Show vbModal, Me
End Sub

Private Sub popCopy_Click()
    mnuCopy_Click
End Sub

Private Sub pop_rtfChat_Click()
    mnuEdit_Click
End Sub

Private Sub popSelectAll_Click()
    mnuSelectAll_Click
End Sub

Private Sub rtfChat_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 1 Then
        Clipboard.Clear
        Clipboard.SetText rtfChat.SelText, vbCFText
        rtfChat.SelLength = 0
        cboChat.SetFocus
    ElseIf Button = 2 Then
        pop_rtfChat_Click
        PopupMenu pop_rtfChat, vbPopupMenuRightButton
    End If
End Sub

Private Sub tmrDelay_Timer()
    tmrDelay.Enabled = False
End Sub

Private Sub wskBNet_Close()
    If g_Telnet Then
        If wskTelnet.State <> 0 Then
            g_Telnet = False
            AddChat vbYellow, "Disconnected from " & wskTelnet.RemoteHost & " (" & wskTelnet.RemoteHostIP & ")."
            wskTelnet.Close
        End If
    End If
    If wskBNet.State <> 0 Then
        wskBNet.Close
        AddChat vbYellow, "Disconnected from Battle.net (" & g_Server & ")."
    End If
End Sub

Private Sub wskBNet_Connect()
    wskBNet.SendData Chr(3) & Chr(4) & g_Username & vbCrLf & g_Password & vbCrLf
    AddChat vbYellow, "Connected to Battle.net (" & g_Server & ")."
    If wskTelnet.State <> 0 Then wskTelnet.Close
    wskTelnet.LocalPort = 9798
    wskTelnet.Listen
End Sub

Private Sub wskBNet_DataArrival(ByVal bytesTotal As Long)
    Dim s$
    Dim t$
    Dim i&
    Dim n&
    Dim a
    Dim e
    Dim p

    If (wskBNet.State <> 8) And (wskBNet.State <> 9) Then
        wskBNet.GetData s, vbString
        a = Split(s, Chr(13))
        For i = LBound(a) To UBound(a)
            If Left(a(i), 1) = Chr(10) Then a(i) = Right(a(i), Len(a(i)) - 1)
            e = Split(a(i), Chr(32), 1)
            Select Case e(0)
                Case "1001"
                    p = Split(a(i), Chr(32), 5)
                    p(4) = Mid(p(4), 2, Len(p(4)) - 2)
                    n = 0
                    Select Case p(4)
                        Case CHAT: n = ICON_CHAT
                        Case DRTL: n = ICON_DRTL
                        Case DSHR: n = ICON_DSHR
                        Case STAR: n = ICON_STAR
                        Case SSHR: n = ICON_SSHR
                        Case JSTR: n = ICON_JSTR
                        Case SEXP: n = ICON_SEXP
                        Case W2BN: n = ICON_W2BN
                        Case D2DV: n = ICON_D2DV
                        Case D2XP: n = ICON_D2XP
                        Case WAR3: n = ICON_WAR3
                        Case Else: n = ICON_UNKNOWN
                    End Select
                    If (HexToDec(CLng(p(3)))) And (FLAG_BLIZZARD) Then n = ICON_BLIZZARD
                    If (HexToDec(CLng(p(3)))) And (FLAG_OP) Then n = ICON_OP
                    If (HexToDec(CLng(p(3)))) And (FLAG_SPEAKER) Then n = ICON_SPEAKER
                    If (HexToDec(CLng(p(3)))) And (FLAG_SYSADMIN) Then n = ICON_SYSADMIN
                    If (HexToDec(CLng(p(3)))) And (FLAG_SQUELCHED) Then n = ICON_SQUELCHED
                    If (HexToDec(CLng(p(3)))) And (FLAG_SPECTATOR) Then n = ICON_SPECTATOR
                    AddNick p(2) & "&" & p(4), p(2), n
                    ChannelName g_ChannelName
                Case "1002"
                    p = Split(a(i), Chr(32), 5)
                    p(4) = Mid(p(4), 2, Len(p(4)) - 2)
                    n = 0
                    Select Case p(4)
                        Case CHAT
                            n = ICON_CHAT
                            t = "chat"
                        Case DRTL
                            n = ICON_DRTL
                            t = "Diablo"
                        Case DSHR
                            n = ICON_DSHR
                            t = "Diablo: Shareware"
                        Case STAR
                            n = ICON_STAR
                            t = "StarCraft"
                        Case SSHR
                            n = ICON_SSHR
                            t = "StarCraft: Shareware"
                        Case JSTR
                            n = ICON_JSTR
                            t = "Japanese Starcraft"
                        Case SEXP
                            n = ICON_SEXP
                            t = "StarCraft: Brood War"
                        Case W2BN
                            n = ICON_W2BN
                            t = "Warcraft II Battle.net Edition"
                        Case D2DV
                            n = ICON_D2DV
                            t = "Diablo II"
                        Case D2XP
                            n = ICON_D2XP
                            t = "Diablo II: Lord of Destruction"
                        Case WAR3
                            n = ICON_WAR3
                            t = "Warcraft III: Reign of Chaos"
                        Case Else
                            n = 21
                            t = "Unknown"
                    End Select
                    If (HexToDec(CLng(p(3)))) And (FLAG_BLIZZARD) Then n = ICON_BLIZZARD
                    If (HexToDec(CLng(p(3)))) And (FLAG_OP) Then n = ICON_OP
                    If (HexToDec(CLng(p(3)))) And (FLAG_SPEAKER) Then n = ICON_SPEAKER
                    If (HexToDec(CLng(p(3)))) And (FLAG_SYSADMIN) Then n = ICON_SYSADMIN
                    If (HexToDec(CLng(p(3)))) And (FLAG_SQUELCHED) Then n = ICON_SQUELCHED
                    If (HexToDec(CLng(p(3)))) And (FLAG_SPECTATOR) Then n = ICON_SPECTATOR
                    AddChat vbGreen, p(2) & " has joined the channel using " & t & "."
                    AddNick p(2) & "&" & p(4), p(2), n
                    ChannelName g_ChannelName
                Case "1003"
                    p = Split(a(i), Chr(32), 3)
                    AddChat vbGreen, p(2) & " has left the channel."
                    DelNick p(2)
                    ChannelName g_ChannelName
                Case "1004"
                    p = Split(a(i), Chr(32), 4)
                    If p(2) = g_ConnectedUsername Then
                        AddChat vbCyan, "<From: " & p(2) & "> ", RGB(192, 192, 192), Mid(p(4), 2, Len(p(4)) - 2)
                    Else
                        AddChat RGB(192, 192, 192), "<From: " & p(2) & "> " & Mid(p(4), 2, Len(p(4)) - 2)
                    End If
                Case "1005"
                    p = Split(a(i), Chr(32), 4)
                    If (HexToDec(CLng(p(3)))) And (FLAG_OP) Then
                        AddChat vbWhite, "<" & p(2) & "> " & Mid(p(4), 2, Len(p(4)) - 2)
                    Else
                        AddChat vbYellow, "<" & p(2) & "> ", vbWhite, Mid(p(4), 2, Len(p(4)) - 2)
                    End If
                Case "1007"
                    p = Split(a(i), Chr(32), 2)
                    lvwNickList.ListItems.Clear
                    g_ChannelName = Mid(p(2), 2, Len(p(2)) - 2)
                    ChannelName g_ChannelName
                    AddChat vbGreen, "You have joined channel " & g_ChannelName & "."
                Case "1009"
                    p = Split(a(i), Chr(32), 3)
                    n = 0
                    If (HexToDec(CLng(p(3)))) And (FLAG_OP) Then n = ICON_OP
                    If (HexToDec(CLng(p(3)))) And (FLAG_SQUELCHED) Then n = ICON_SQUELCHED
                    If (p(2) = g_ConnectedUsername) And ((HexToDec(CLng(p(3)))) And (FLAG_OP)) Then
                        g_Op = True
                    Else
                        g_Op = False
                    End If
                    EditNick p(2), n
                Case "1010"
                    p = Split(a(i), Chr(32), 4)
                    AddChat vbCyan, "<To: " & p(2) & "> ", RGB(192, 192, 192), Mid(p(4), 2, Len(p(4)) - 2)
                Case "1018"
                    p = Split(a(i), Chr(32), 2)
                    AddChat vbYellow, Mid(p(2), 2, Len(p(2)) - 2)
                Case "1019"
                    p = Split(a(i), Chr(32), 2)
                    AddChat vbRed, "Error: " & Mid(p(2), 2, Len(p(2)) - 2)
                Case "1023"
                    p = Split(a(i), Chr(32), 4)
                    If p(2) = g_ConnectedUsername Then
                        AddChat vbCyan, "<" & p(2) & " " & Mid(p(4), 2, Len(p(4)) - 2) & "> "
                    ElseIf ((HexToDec(CLng(p(3)))) And (FLAG_OP)) Then
                        AddChat vbWhite, "<" & p(2) & " " & Mid(p(4), 2, Len(p(4)) - 2) & "> "
                    Else
                        AddChat vbYellow, "<" & p(2) & " " & Mid(p(4), 2, Len(p(4)) - 2) & "> "
                    End If
                Case "2000"
                    '
                Case "2010"
                    p = Split(a(i), Chr(32), 2)
                    g_ConnectedUsername = p(2)
                Case Else
                    'AddChat vbBlack, a(i)
            End Select
        Next i
    End If
End Sub

Private Sub wskBNet_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    MsgBox "Error: " & Number & vbNewLine & "Description: " & Description, vbOKOnly + vbExclamation, App.Title & " WinSock Error"
    AddChat vbRed, "Error: " & Description
    If wskBNet.State <> 0 Then
        If g_Telnet Then
            If wskTelnet.State <> 0 Then
                g_Telnet = False
                AddChat vbYellow, "Disconnected from " & wskTelnet.RemoteHost & " (" & wskTelnet.RemoteHostIP & ")."
                wskTelnet.SendData "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] Disconnected from " & wskTelnet.LocalHostName & " (" & wskTelnet.LocalIP & ")." & vbCrLf
                wskTelnet.Close
            End If
        End If
        wskBNet.Close
        AddChat vbYellow, "Disconnected from Battle.net (" & g_Server & ")."
    End If
End Sub

Private Sub wskTelnet_Close()
    g_Telnet = False
    If wskTelnet.State <> 0 Then
        AddChat vbYellow, "Disconnected from " & wskTelnet.RemoteHost & " (" & wskTelnet.RemoteHostIP & ")."
        wskTelnet.Close
        wskTelnet.Listen
    End If
End Sub

Private Sub wskTelnet_ConnectionRequest(ByVal requestID As Long)
    wskTelnet.Close
    wskTelnet.Accept requestID
    AddChat vbYellow, "Connected to " & wskTelnet.RemoteHost & " (" & wskTelnet.RemoteHostIP & ")."
    wskTelnet.SendData "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] Connected to " & wskTelnet.LocalHostName & " (" & wskTelnet.LocalIP & ")." & vbCrLf
    m_TelnetLogon = True
    wskTelnet.SendData "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] " & "Passowrd: "
End Sub

Private Sub wskTelnet_DataArrival(ByVal bytesTotal As Long)
    Dim s$
    
    If (wskTelnet.State <> 8) And (wskTelnet.State <> 9) Then
        wskTelnet.GetData s, vbString
        If (s = vbCrLf) And (m_s <> "") Then
            If m_TelnetLogon Then
                If m_s <> g_Password Then
                    If wskTelnet.State <> 0 Then
                        g_Telnet = False
                        AddChat vbRed, "Error: Password rejected."
                        AddChat vbYellow, "Disconnected from " & wskTelnet.RemoteHost & " (" & wskTelnet.RemoteHostIP & ")."
                        With wskTelnet
                            .SendData "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] Disconnected from " & wskTelnet.LocalHostName & " (" & wskTelnet.LocalIP & ")." & vbCrLf
                            .Close
                            .Listen
                        End With
                    End If
                Else
                    g_Telnet = True
                    AddChat vbYellow, "Password accepted."
                    'wskTelnet.SendData "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] " & vbCrLf
                End If
                m_TelnetLogon = False
                m_s = ""
            Else
                wskBNet.SendData m_s & vbCrLf
                If g_Telnet Then
                    tmrDelay.Enabled = True
                    Do While tmrDelay.Enabled
                        DoEvents
                    Loop
                End If
                If Left(m_s, 1) <> "/" Then AddChat vbCyan, "<" & g_ConnectedUsername & "> ", vbWhite, m_s
                m_s = ""
            End If
        Else
            If Asc(s) > 31 Then m_s = m_s & s
        End If
    End If
End Sub

Private Sub wskTelnet_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    g_Telnet = False
    AddChat vbRed, "Error: " & Description
    If wskTelnet.State <> 0 Then
        AddChat vbYellow, "Disconnected from " & wskTelnet.RemoteHost & " (" & wskTelnet.RemoteHostIP & ")."
        wskTelnet.Close
    End If
    wskTelnet.Listen
End Sub

