VERSION 5.00
Begin VB.Form frmSetup 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "frmSetup"
   ClientHeight    =   3255
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3375
   Icon            =   "SETUP.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3255
   ScaleWidth      =   3375
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   960
      TabIndex        =   8
      Top             =   2760
      Width           =   1095
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   2160
      TabIndex        =   7
      Top             =   2760
      Width           =   1095
   End
   Begin VB.Frame fraSetup 
      Caption         =   "&Setup"
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
      Begin VB.TextBox txtPassword 
         Height          =   315
         Left            =   240
         TabIndex        =   4
         Top             =   1320
         Width           =   2655
      End
      Begin VB.TextBox txtUsername 
         Height          =   315
         Left            =   240
         TabIndex        =   2
         Top             =   600
         Width           =   2655
      End
      Begin VB.ComboBox cboServer 
         Height          =   315
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   6
         Top             =   2040
         Width           =   2655
      End
      Begin VB.Label lblServer 
         Caption         =   "S&erver:"
         Height          =   195
         Left            =   240
         TabIndex        =   5
         Top             =   1800
         Width           =   510
      End
      Begin VB.Label lblPassword 
         Caption         =   "&Password:"
         Height          =   195
         Left            =   240
         TabIndex        =   3
         Top             =   1080
         Width           =   735
      End
      Begin VB.Label lblUsername 
         Caption         =   "&Username:"
         Height          =   195
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   765
      End
   End
End
Attribute VB_Name = "frmSetup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'SETUP.FRM (frmSetup) - Ickis <ickis@toctep.com>.

'MMII Weatherspoon Labs <http://toctep.com/>.  All rights reserved.

'Permission to use, copy, modify, and distribute this software and its
'documentation for non-commercial purposes and without fee is hereby granted.

Option Explicit

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOk_Click()
    Dim r&
    Dim s
    Dim b As Boolean
    
    s = Split(cboServer.Text, Chr(32))
    If (frmMain.wskBNet.State <> 0) And ((txtUsername.Text <> g_Username) Or (txtPassword.Text <> g_Password) Or (s(0) <> g_Server)) Then
        b = False
        If frmMain.wskBNet.State = 7 Then b = True
        r = MsgBox("You are currently not disconnected.  You need to disconnect before continuing." & vbNewLine & "Would you like to disconnect now?", vbYesNo + vbQuestion, App.Title & " Error")
        If r = vbYes Then
            If g_Telnet Then
                If frmMain.wskTelnet.State <> 0 Then
                    g_Telnet = False
                    AddChat vbYellow, "Disconnected from " & frmMain.wskTelnet.RemoteHost & " (" & frmMain.wskTelnet.RemoteHostIP & ")."
                    With frmMain.wskTelnet
                        .SendData "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] Disconnected from " & frmMain.wskTelnet.LocalHostName & " (" & frmMain.wskTelnet.LocalIP & ")." & vbCrLf
                        .Close
                        .Listen
                    End With
                End If
            End If
            If frmMain.wskBNet.State <> 0 Then
                frmMain.wskBNet.Close
                AddChat vbYellow, "Disconnected from Battle.net (" & g_Server & ")."
            End If
        ElseIf r = vbNo Then
            Unload Me
            Exit Sub
        End If
    End If
    g_Username = txtUsername.Text
    WriteINI "Setup", "Username", g_Username, FixPath(App.Path) & "assbot.ini"
    g_Password = txtPassword.Text
    WriteINI "Setup", "Password", g_Password, FixPath(App.Path) & "assbot.ini"
    g_Server = s(0)
    WriteINI "Setup", "Server", g_Server, FixPath(App.Path) & "assbot.ini"
    If b Then frmMain.mnuConnect_Click
    Unload Me
End Sub

Private Sub Form_Load()
    Dim r&
    Dim i&
    Dim s
    
    If g_OnTop Then r = SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    Me.Caption = App.Title & " Setup"
    With cboServer
        .AddItem "127.0.0.1 (Localhost)"
        .AddItem "211.233.0.49 (Asia)"
        .AddItem "211.233.0.50 (Asia)"
        .AddItem "211.233.0.51 (Asia)"
        .AddItem "211.233.0.52 (Asia)"
        .AddItem "211.233.0.53 (Asia)"
        .AddItem "211.233.0.54 (Asia)"
        .AddItem "211.233.0.55 (Asia)"
        .AddItem "211.233.0.56 (Asia)"
        .AddItem "211.233.0.57 (Asia)"
        .AddItem "211.233.0.58 (Asia)"
        .AddItem "211.233.0.59 (Asia)"
        .AddItem "211.233.0.60 (Asia)"
        .AddItem "211.233.0.61 (Asia)"
        .AddItem "211.233.0.62 (Asia)"
        .AddItem "211.233.0.63 (Asia)"
        .AddItem "211.233.0.64 (Asia)"
        .AddItem "211.233.0.72 (Asia)"
        .AddItem "211.233.0.73 (Asia)"
        .AddItem "211.233.0.74 (Asia)"
        .AddItem "211.233.0.75 (Asia)"
        .AddItem "211.233.0.76 (Asia)"
        .AddItem "211.233.0.78 (Asia)"
        .AddItem "211.233.0.79 (Asia)"
        .AddItem "211.233.0.80 (Asia)"
        .AddItem "213.248.106.200 (Europe)"
        .AddItem "213.248.106.201 (Europe)"
        .AddItem "213.248.106.202 (Europe)"
        .AddItem "213.248.106.204 (Europe)"
        .AddItem "63.240.202.120 (USEast)"
        .AddItem "63.240.202.121 (USEast)"
        .AddItem "63.240.202.122 (USEast)"
        .AddItem "63.240.202.126 (USEast)"
        .AddItem "63.240.202.127 (USEast)"
        .AddItem "63.240.202.128 (USEast)"
        .AddItem "63.240.202.129 (USEast)"
        .AddItem "63.240.202.130 (USEast)"
        .AddItem "63.240.202.131 (USEast)"
        .AddItem "63.240.202.134 (USEast)"
        .AddItem "63.240.202.138 (USEast)"
        .AddItem "63.240.202.139 (USEast)"
        .AddItem "63.241.83.7 (USWest)"
        .AddItem "63.241.83.8 (USWest)"
        .AddItem "63.241.83.9 (USWest)"
        .AddItem "63.241.83.11 (USWest)"
        .AddItem "63.241.83.12 (USWest)"
        .AddItem "63.241.83.13 (USWest)"
        .AddItem "63.241.83.107 (USWest)"
        .AddItem "63.241.83.108 (USWest)"
        .AddItem "63.241.83.109 (USWest)"
        .AddItem "63.241.83.110 (USWest)"
        .AddItem "63.241.83.111 (USWest)"
        .AddItem "63.241.83.112 (USWest)"
    End With
    cmdOk.Default = True
    cmdCancel.Cancel = True
    txtUsername.Text = g_Username
    txtPassword.Text = g_Password
    For i = 0 To cboServer.ListCount - 1
        s = Split(cboServer.List(i), Chr(32))
        If s(0) = g_Server Then
            cboServer.ListIndex = i
            Exit For
        End If
    Next i
    CenterForm Me
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim r&
    
    If g_OnTop Then r = SetWindowPos(frmMain.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    Set frmSetup = Nothing
End Sub

Private Sub txtPassword_GotFocus()
    HighlightText txtPassword
End Sub

Private Sub txtUsername_GotFocus()
    HighlightText txtUsername
End Sub

